#include "stdafx.h"
#include "app.h"
#include "window.h"
using namespace ki;



//=========================================================================
// IMEɊւ邠ꂱ
//=========================================================================

IMEManager* IMEManager::pUniqueInstance_;

IMEManager::IMEManager()
#ifdef USEGLOBALIME
	: immApp_( NULL )
	, immMsg_( NULL )
#endif
{
	#ifdef USEGLOBALIME
		// FXʓ|Ȃ̂Win95łGlobalIME
		if( !app().isWin95() )
		{
			app().InitModule( App::OLE );
			if( S_OK == ::CoCreateInstance(
					CLSID_CActiveIMM, NULL, CLSCTX_INPROC_SERVER,
					IID_IActiveIMMApp, (void**)&immApp_ ) )
			{
				immApp_->QueryInterface(
					IID_IActiveIMMMessagePumpOwner, (void**)&immMsg_ );
			}
		}
	#endif

	// B̃CX^X͎ł
	pUniqueInstance_ = this;
}

IMEManager::~IMEManager()
{
	#ifdef USEGLOBALIME
		if( immMsg_ != NULL )
			immMsg_->Release();
		if( immApp_ != NULL )
			immApp_->Release();
	#endif
}

void IMEManager::EnableGlobalIME( bool enable )
{
	#ifdef USEGLOBALIME
		if( immApp_ )
			if( enable ) immApp_->Activate( TRUE );
			else         immApp_->Deactivate();
	#endif
}

void IMEManager::FilterWindows( ATOM* lst, UINT siz )
{
	#ifdef USEGLOBALIME
		if( immApp_ )
			immApp_->FilterClientWindows( lst, siz );
	#endif
}

inline void IMEManager::TranslateMsg( MSG* msg )
{
	#ifdef USEGLOBALIME
		if( immMsg_ )
			if( S_OK == immMsg_->OnTranslateMessage( msg ) )
				return;
	#endif
	::TranslateMessage( msg );
}

inline LRESULT IMEManager::DefProc( HWND h, UINT m, WPARAM w, LPARAM l )
{
	#ifdef USEGLOBALIME
		if( immApp_ )
		{
			LRESULT res;
			if( S_OK == immApp_->OnDefWindowProc( h,m,w,l,&res ) )
				return res;
		}
	#endif
	return ::DefWindowProc( h, m, w, l );
}

inline void IMEManager::MsgLoopBegin()
{
	#ifdef USEGLOBALIME
		if( immMsg_ )
			immMsg_->Start();
	#endif
}

inline void IMEManager::MsgLoopEnd()
{
	#ifdef USEGLOBALIME
		if( immMsg_ )
			immMsg_->End();
	#endif
}

void IMEManager::SetFont( HWND wnd, const LOGFONT& lf )
{
	HIMC ime;
	LOGFONT* plf = const_cast<LOGFONT*>(&lf);

	#ifdef USEGLOBALIME
	if( immApp_ )
	{
		immApp_->GetContext( wnd, &ime );
		#ifdef _UNICODE
			immApp_->SetCompositionFontW( ime, plf );
		#else
			immApp_->SetCompositionFontA( ime, plf );
		#endif
		immApp_->ReleaseContext( wnd, ime );
	}
	else
	#endif
	{
		ime = ::ImmGetContext( wnd );
		::ImmSetCompositionFont( ime, plf );
		::ImmReleaseContext( wnd, ime );
	}
}

void IMEManager::SetPos( HWND wnd, int x, int y )
{
	HIMC ime;
	COMPOSITIONFORM cf;
	cf.dwStyle = CFS_POINT;
	cf.ptCurrentPos.x  = x;
	cf.ptCurrentPos.y  = y;

	#ifdef USEGLOBALIME
	if( immApp_ )
	{
		immApp_->GetContext( wnd, &ime );
		immApp_->SetCompositionWindow( ime, &cf );
		immApp_->ReleaseContext( wnd, ime );
	}
	else
	#endif
	{
		ime = ::ImmGetContext( wnd );
		::ImmSetCompositionWindow( ime, &cf );
		::ImmReleaseContext( wnd, ime );
	}
}

void IMEManager::GetString( HWND wnd, unicode** str, ulong* len )
{
	*str = NULL;
	HIMC ime;

	#ifdef USEGLOBALIME
	if( immApp_ )
	{
		long s=0;
		immApp_->GetContext( wnd, &ime );
		immApp_->GetCompositionStringW( ime, GCS_RESULTSTR, 0, &s, NULL );
		*str = new unicode[ (*len=s/2)+1 ];
		immApp_->GetCompositionStringW( ime, GCS_RESULTSTR, s, &s, *str );
		immApp_->ReleaseContext( wnd, ime );
	}
	else
	#endif
	{
		ime = ::ImmGetContext( wnd );
		long s = ::ImmGetCompositionStringW( ime,GCS_RESULTSTR,NULL,0 );

		#ifndef _UNICODE
			if( s <= 0 )
			{
				s = ::ImmGetCompositionStringA(ime,GCS_RESULTSTR,NULL,0);
				if( s > 0 )
				{
					char* tmp = new char[s];
					*str = new unicode[*len=s*2];
					::ImmGetCompositionStringA( ime,GCS_RESULTSTR,tmp,s );
					*len = ::MultiByteToWideChar(
						CP_ACP, MB_PRECOMPOSED, tmp, s, *str, *len );
					delete [] tmp;
				}
			}
			else
		#endif
			{
				*str = new unicode[ (*len=s/2)+1 ];
				::ImmGetCompositionStringW( ime, GCS_RESULTSTR, *str, s );
			}

		::ImmReleaseContext( wnd, ime );
	}
}



//=========================================================================
// WindowɊւ邠ꂱ
//=========================================================================

Window::Window()
	: wnd_      (NULL)
	, isLooping_(false)
{
}

void Window::SetHwnd( HWND wnd )
{
	wnd_ = wnd;
}

void Window::MsgLoop()
{
	// thisCEChEƂāA
	// CbZ[W[v
	isLooping_ = true;
	ime().MsgLoopBegin();

	for( MSG msg; ::GetMessage( &msg, NULL, 0, 0 ); )
		if( !PreTranslateMessage( &msg ) )
		{
			ime().TranslateMsg( &msg );
			::DispatchMessage( &msg );
		}

	ime().MsgLoopEnd();
	isLooping_ = false;
}

void Window::ProcessMsg()
{
	// ̓O[o֐B
	// bZ[W|

	ime().MsgLoopBegin();
	for( MSG msg; ::PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ); )
	{
		ime().TranslateMsg( &msg );
		::DispatchMessage( &msg );
	}
	ime().MsgLoopEnd();
}



//-------------------------------------------------------------------------

void Window::SetCenter( HWND hwnd, HWND rel )
{
	// ̃TCY擾
	RECT rc,pr;
	::GetWindowRect( hwnd, &rc );

	// ëʒuAȂ͑Sʂ̈ʒu擾
	if( rel != NULL )
		::GetWindowRect( rel, &pr );
	else
		::SystemParametersInfo( SPI_GETWORKAREA, 0, &pr, 0 );

	// vZ
	::SetWindowPos( hwnd, 0,
		pr.left + ( (pr.right-pr.left)-(rc.right-rc.left) )/2,
		pr.top  + ( (pr.bottom-pr.top)-(rc.bottom-rc.top) )/2,
		0, 0, SWP_NOSIZE|SWP_NOZORDER );
}

void Window::SetFront( HWND hwnd )
{
	// kazubon TClock ̃\[XQlɂ܂BӁI

	if( app().isNewTypeWindows() )
	{
		DWORD pid;
		HWND  fore= ::GetForegroundWindow();
		DWORD th1 = ::GetWindowThreadProcessId( fore, &pid );
		DWORD th2 = ::GetCurrentThreadId();
		::AttachThreadInput( th2, th1, TRUE );
		::SetForegroundWindow( hwnd );
		::AttachThreadInput( th2, th1, FALSE );
		::BringWindowToTop( hwnd );
	}
	else
	{
		::SetForegroundWindow( hwnd );
	}
}

static void CALLBACK timeout_mb( HWND, UINT, UINT, DWORD )
{
	::PostQuitMessage( 0 );
}

int Window::MsgBoxCoreRoutine(
		HWND wnd, LPCTSTR msg, LPCTSTR caption, UINT type, int timeout )
{
	// MicrosoftKnowledge BasẻԂiYꂽ(^^;jQlɂ܂B

	UINT id;
	if( timeout != -1 )
	{
		// Ԃ؂WM_QUIT𓊂^C}[d|Ă
		id = ::SetTimer( NULL, 0, timeout, (TIMERPROC)timeout_mb );
		type &= ~MB_TASKMODAL;
	}

	// bZ[W{bNX\
	int ans = ::MessageBox( wnd, msg, caption, type );

	if( timeout != -1 )
	{
		::KillTimer( NULL, id );

		MSG msg;
		if( ::PeekMessage( &msg, NULL, WM_QUIT, WM_QUIT, PM_REMOVE ) )
		{
			// WM_QUIT͎菜Ă
			ans = IDTIMEOUT;
			while( wnd != NULL )
			{
				if( ::GetWindowLong( wnd, GWL_STYLE ) & WS_CHILD )
				{
					wnd = ::GetParent( wnd );
				}
				else
				{
					::EnableWindow( wnd, TRUE );
					Window::SetFront( wnd );
					wnd = NULL;
				}
			}
		}
	}
	return ans;
}



//=========================================================================

WndImpl::WndImpl( LPCTSTR className, DWORD style, DWORD styleEx )
	: className_( className )
	, style_( style )
	, styleEx_( styleEx )
{
}

WndImpl::~WndImpl()
{
	// EChEjYĂ
	// cA̎_Ŋ vtable ͔jꂩĂ̂
	//  on_destroy Ă΂ۏ؂͑SȂB܂
	// ً}Eop(^^; ƍl邱ƁB
	Destroy();
}

void WndImpl::Destroy()
{
	if( hwnd() != NULL )
		::DestroyWindow( hwnd() );
}

ATOM WndImpl::Register( WNDCLASSEX* cls )
{
	// WndImplhNXŎgWndClasso^B
	// vV[Wkilibސ̂̂ɏႢ܂B
	cls->cbSize      = sizeof(WNDCLASSEX);
	cls->hInstance   = app().hinst();
	cls->lpfnWndProc = StartProc;
	return ::RegisterClassEx( cls );
}

struct ThisAndParam
{
	// [Uw̃p[^ȊOɂnmXc
	WndImpl* pThis;
	void*   pParam;
};

bool WndImpl::Create(
	LPCTSTR wndName, HWND parent, int x, int y, int w, int h, void* param )
{
	// this|C^Eэ܂Ă
	ThisAndParam z = { this, param };

	return (NULL != ::CreateWindowEx(
		styleEx_, className_, wndName, style_,
		x, y, w, h, parent, NULL, app().hinst(), &z
	));
}



//-------------------------------------------------------------------------

LRESULT CALLBACK WndImpl::StartProc(
	HWND wnd, UINT msg, WPARAM wp, LPARAM lp )
{
	// WM_CREATEȊO̓X[̕j
	if( msg != WM_CREATE )
		return ::DefWindowProc( wnd, msg, wp, lp );

	// E΂Ēuthis|C^o
	CREATESTRUCT* cs   = reinterpret_cast<CREATESTRUCT*>(lp);
	ThisAndParam* pz   = static_cast<ThisAndParam*>(cs->lpCreateParams);
	WndImpl*   pThis   = pz->pThis;
	cs->lpCreateParams = pz->pParam;

	// TN
	pThis->SetUpThunk( wnd );

	// WM_CREATEpbZ[WĂ
	pThis->on_create( cs );
	return 0;
}

void WndImpl::SetUpThunk( HWND wnd )
{
	SetHwnd( wnd );

	// œIx86̖ߗ
	//   | mov dword ptr [esp+4] this
	//   | jmp MainProc
	// 𐶐AbZ[WvV[WƂčւB
	//
	// Ŏ񂩂́A hwnd ̂
	// this|C^ɂȂԂMainProcĂ΂
	// cƌȂvOB
	//
	// ƂAȂłꂪ̂킩(^^;
	// ȓKȂƂɊmۂs\łł傤B
	// ATL̃\[XȂAWinMeƊmɓ炢񂾂ǁc

	*reinterpret_cast<qbyte*>   (thunk_+0) = 0x042444C7;
	*reinterpret_cast<WndImpl**>(thunk_+4) = this;
	                           *(thunk_+8) = 0xE9;
	*reinterpret_cast<qbyte*>   (thunk_+9) =
		reinterpret_cast<byte*>(MainProc)-(thunk_+13);

	::FlushInstructionCache( ::GetCurrentProcess(), thunk_, 13 );
	::SetWindowLong( wnd, GWL_WNDPROC, reinterpret_cast<long>(thunk_) );
}

LRESULT CALLBACK WndImpl::MainProc(
	WndImpl* ptr, UINT msg, WPARAM wp, LPARAM lp )
{
	if( msg == WM_COMMAND )
	{
		if( !ptr->on_command( LOWORD(wp), (HWND)lp ) )
			return ::DefWindowProc( ptr->hwnd(), msg, wp, lp );
	}
	else if( msg == WM_DESTROY )
	{
		ptr->on_destroy();
		::SetWindowLong( ptr->hwnd(), GWL_WNDPROC,
			reinterpret_cast<long>(StartProc) );
		if( ptr->isMainWnd() )
			::PostQuitMessage( 0 );
		ptr->SetHwnd(NULL);
	}
	else
	{
		return ptr->on_message( msg, wp, lp );
	}

	return 0;
}



//-------------------------------------------------------------------------

void WndImpl::on_create( CREATESTRUCT* cs )
{
	// Ȃ
}

void WndImpl::on_destroy()
{
	// Ȃ
}

bool WndImpl::on_command( UINT, HWND )
{
	// Ȃ
	return false;
}

LRESULT WndImpl::on_message( UINT msg, WPARAM wp, LPARAM lp )
{
	// Ȃ
	return ime().DefProc( hwnd(), msg, wp, lp );
}

bool WndImpl::PreTranslateMessage( MSG* )
{
	// Ȃ
	return false;
}



//=========================================================================

DlgImpl::DlgImpl( UINT id )
	: rsrcID_( id )
{
}

DlgImpl::~DlgImpl()
{
	// EChEjYĂ
	if( hwnd() != NULL )
		End( IDCANCEL );
}

void DlgImpl::End( UINT code )
{
	endCode_ = code;

	if( type() == MODAL )
		::EndDialog( hwnd(), code );
	else
		::DestroyWindow( hwnd() );
}

void DlgImpl::GoModal( HWND parent )
{
	type_ = MODAL;
	::DialogBoxParam( app().hinst(), MAKEINTRESOURCE(rsrcID_), parent,
		(DLGPROC)MainProc, reinterpret_cast<LPARAM>(this) );
}

void DlgImpl::GoModeless( HWND parent )
{
	type_ = MODELESS;
	::CreateDialogParam( app().hinst(), MAKEINTRESOURCE(rsrcID_), parent,
		(DLGPROC)MainProc, reinterpret_cast<LPARAM>(this) );
}



//-------------------------------------------------------------------------

BOOL CALLBACK DlgImpl::MainProc(
	HWND dlg, UINT msg, WPARAM wp, LPARAM lp )
{
	if( msg == WM_INITDIALOG )
	{
		::SetWindowLong( dlg, GWL_USERDATA, lp );

		DlgImpl* ptr = reinterpret_cast<DlgImpl*>(lp);
		ptr->SetHwnd( dlg );
		ptr->on_init();
		return FALSE;
	}

	DlgImpl* ptr =
		reinterpret_cast<DlgImpl*>(::GetWindowLong(dlg,GWL_USERDATA));

	if( ptr != NULL )
		switch( msg )
		{
		case WM_COMMAND:
			switch( LOWORD(wp) )
			{
			case IDOK:
				if( ptr->on_ok() )
					ptr->End( IDOK );
				return TRUE;

			case IDCANCEL:
				if( ptr->on_cancel() )
					ptr->End( IDCANCEL );
				return TRUE;

			default:
				return ptr->on_command( HIWORD(wp), LOWORD(wp),
					reinterpret_cast<HWND>(lp) ) ? TRUE : FALSE;
			}

		case WM_DESTROY:
			ptr->on_destroy();
			if( ptr->isMainWnd() )
				::PostQuitMessage( 0 );
			ptr->SetHwnd(NULL);
			break;

		default:
			return ptr->on_message( msg, wp, lp ) ? TRUE : FALSE;
		}

	return FALSE;
}



//-------------------------------------------------------------------------

void DlgImpl::on_init()
{
	// Ȃ
}

void DlgImpl::on_destroy()
{
	// Ȃ
}

bool DlgImpl::on_ok()
{
	// Ȃ
	return true;
}

bool DlgImpl::on_cancel()
{
	// Ȃ
	return true;
}

bool DlgImpl::on_command( UINT, UINT, HWND )
{
	// Ȃ
	return false;
}

bool DlgImpl::on_message( UINT, WPARAM, LPARAM )
{
	// Ȃ
	return false;
}

bool DlgImpl::PreTranslateMessage( MSG* msg )
{
	// [hX̎pB_CAObZ[WB
	return (FALSE != ::IsDialogMessage( hwnd(), msg ));
}
